"use strict";

var _react = _interopRequireDefault(require("react"));

var _enzyme = require("enzyme");

var _Body = _interopRequireDefault(require("../Body"));

var _Tracks = _interopRequireDefault(require("../Tracks"));

var _Grid = _interopRequireDefault(require("../Grid"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var defaultProps = {
  time: {},
  grid: [],
  tracks: []
};
describe('<Body />', function () {
  it('renders <Tracks />', function () {
    var wrapper = (0, _enzyme.shallow)(_react.default.createElement(_Body.default, defaultProps));
    expect(wrapper.find(_Tracks.default).exists()).toBe(true);
  });
  it('renders <Grid /> if grid prop exists', function () {
    var wrapper = (0, _enzyme.shallow)(_react.default.createElement(_Body.default, defaultProps));
    expect(wrapper.find(_Grid.default).exists()).toBe(true);
  });
  it('does not render <Grid /> if grid prop does not exist', function () {
    var props = _objectSpread({}, defaultProps, {
      grid: undefined
    });

    var wrapper = (0, _enzyme.shallow)(_react.default.createElement(_Body.default, props));
    expect(wrapper.find(_Grid.default).exists()).toBe(false);
  });
});